<script>
  import { flip } from 'svelte/animate';
  import { onMount } from 'svelte';
  import { v4 as uuidv4 } from 'uuid';
  import { navigate } from 'svelte-routing';

  let lists = [];
  let loading = false;
  let adding = false;
  let deleting = false;

  async function add(input) {
    const list = {
      id: uuidv4(),
      name: input.value,
    };
    adding = true;
    try {
      const resp = await fetch('http://localhost:8000/api/lists', {
        method: 'POST',
        body: JSON.stringify(list),
        headers: {
          'Content-Type': 'application/json',
        },
      });
      if (resp.status === 201) {
        lists = [list, ...lists];
        input.value = '';
      }
    } catch (error) {
    } finally {
      adding = false;
    }
  }

  async function remove(todo) {
    deleting = true;
    try {
      const resp = await fetch(`http://localhost:8000/api/lists/${todo.id}`, {
        method: 'DELETE',
      });
      if (resp.status === 204) {
        lists = lists.filter((t) => t !== todo);
      }
    } catch (error) {
    } finally {
      deleting = false;
    }
  }

  async function fetchLists() {
    try {
      loading = true;
      const resp = await fetch(`http://localhost:8000/api/lists`, {
        headers: {
          Accept: 'application/json',
        },
      });
      lists = await resp.json();
    } catch (error) {
      lists = [
        {
          id: uuidv4(),
          name: 'Mockup List',
        },
      ];
    } finally {
      loading = false;
    }
  }

  onMount(() => {
    fetchLists();
  });
</script>

<style>
  .board {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 1em;
    max-width: 36em;
    margin: 0 auto;
  }

  .board > input {
    font-size: 1.4em;
    grid-column: 1/3;
  }

  h2 {
    font-size: 2em;
    font-weight: 200;
    user-select: none;
    margin: 0 0 0.5em 0;
  }

  label {
    position: relative;
    line-height: 1.2;
    padding: 0.5em 2.5em 0.5em 1em;
    margin: 0 0 0.5em 0;
    border-radius: 2px;
    user-select: none;
    border: 1px solid hsl(240, 8%, 70%);
    background-color: hsl(240, 8%, 93%);
    color: #333;
    cursor: pointer;
  }

  button {
    position: absolute;
    top: 0;
    right: 0.2em;
    width: 2em;
    height: 100%;
    background: no-repeat 50% 50%
      url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24'%3E%3Cpath fill='%23676778' d='M12,2C17.53,2 22,6.47 22,12C22,17.53 17.53,22 12,22C6.47,22 2,17.53 2,12C2,6.47 6.47,2 12,2M17,7H14.5L13.5,6H10.5L9.5,7H7V9H17V7M9,18H15A1,1 0 0,0 16,17V10H8V17A1,1 0 0,0 9,18Z'%3E%3C/path%3E%3C/svg%3E");
    background-size: 1.4em 1.4em;
    border: none;
    opacity: 0;
    transition: opacity 0.2s;
    text-indent: -9999px;
    cursor: pointer;
  }

  label:hover button {
    opacity: 1;
  }

  .name {
    display: flex;
    align-items: center;
    gap: 0.5em;
    line-height: 1em;
  }
</style>

<div class="board">
  <input placeholder="Enter new list name" on:keydown={(e) => e.key === 'Enter' && add(e.target)} />

  <div>
    <h2>Todo Lists</h2>
    {#if lists.length === 0}
      No lists available yet, try to add one...
    {:else}
      {#each lists as list (list.id)}
        <label animate:flip on:click={() => navigate(`todos/${list.id}`)}>
          <div class="name">
            <span class="icon material-icons"> list </span> <span>{list.name}</span>
          </div>
          <button on:click|stopPropagation|preventDefault={() => remove(list)}>remove</button>
        </label>
      {/each}
    {/if}
  </div>
</div>
